/*  g_ipc_wspolne.h - common stuff for all IPC tests
 *  
 *  (C) Copyright XII 2004 Michal 'GiM' Spadlinski <gim at skrzynka dot pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __G_WSPOLNE_H
#define __G_WSPOLNE_H

#include <stdio.h>
#include <sys/time.h>
#define __USE_SVID
#include <sys/ipc.h>
#include <time.h>

#ifdef DEBUG
#define DEB(x...) fprintf(stderr, x); fflush(stderr)
#else
/* we don't want -pedantic to shout at us :) */
int DEB(char *x, ...);
#endif

#define TIMESTAMP(a) gettimeofday(&a, NULL)
#define DIFFTIME(a,b) do { \
	a.tv_sec -= b.tv_sec; \
	a.tv_usec += 1000000; \
	a.tv_usec -= b.tv_usec; \
	if (a.tv_usec > 1000000) \
		a.tv_usec -= 1000000; \
	} while(0)

#define SLEEP(x, y) do { \
	x.tv_sec = 0; x.tv_usec = y; \
	select(0, NULL, NULL, NULL, &x); \
	} while(0)

#define KB		*1024
#define MB		*1024 KB
#define GB		*1024 MB

/*#define MAX_QUERIES	10*/
#define MAX_OPEN_TRIES	1000

struct g_data_format {
	long type;
	long id;
	char p[IPCQ_S];
};

extern const key_t G_KEY;
extern int MAX_QUERIES;

#endif /* __G_WSPOLNE_H */
